// File: Algorithm-6-1.cpp
// Stan Warford
// September 2020

#include <cstdlib>
#include <iostream>
#include <thread>
#include <mutex>
#include "Util450.cpp"
using namespace std;

volatile int n = 0;
mutex s;

void pRun() {
    int temp;
    for (int i = 0; i < 10; i++) {
        randomDelay(20);
        cout << "p.i == " << i << endl;
        // Preprotocol
        s.lock();
        // Critical section
        temp = n;
        randomDelay(10);
        n = temp + 1;
        // Postprotocol
        s.unlock();
    }
}

void qRun() {
    int temp;
    for (int i = 0; i < 10; i++) {
        randomDelay(10);
        cout << "q.i == " << i << endl;
        // Preprotocol
        s.lock();
        // Critical section
        temp = n;
        randomDelay(10);
        n = temp + 1;
        // Postprotocol
        s.unlock();
    }
}

int main(int argc, char **argv) {
    thread p(pRun);
    thread q(qRun);
    p.join();
    q.join();
    cout << "The value of n is " << n << endl;
    return EXIT_SUCCESS;
}
