// File: Algorithm-7-1.cpp
// Stan Warford
// September 2020
//

#include <cstdlib>
#include <iostream>
#include <thread>
#include <mutex>
#include "Util450.cpp"
using namespace std;

class CriticalSection {
private:
    int n = 0;
    mutex csMutex;
public:
    void increment() {
        lock_guard<mutex> guard(csMutex);
        int temp;
        temp = n;
        randomDelay(40);
        n = temp + 1;
    }

    int get() {
        lock_guard<mutex> guard(csMutex);
        return n;
    }
};

CriticalSection cs;

void pRun() {
    for (int i = 0; i < 10; i++) {
        cout << "p.i == " << i << endl;
        cs.increment();
   }
}

void qRun() {
    for (int i = 0; i < 10; i++) {
        cout << "q.i == " << i << endl;
        cs.increment();
    }
}

int main() {
    thread p(pRun);
    thread q(qRun);
    p.join();
    q.join();
    cout << "The value of n is " << cs.get() << endl;
    return EXIT_SUCCESS;
}
