// File: ReadersWritersA.cpp
// Stan Warford
// December 2020

#include <cstdlib>
#include <iostream>
#include <thread>
#include <mutex>
#include <shared_mutex>
#include "Util450.cpp"

using namespace std;

class RWDataBase {
private:
    int myData = 5;
    shared_mutex rwMutex;
    mutex coutMutex;

public:
    void readMyData(int readerID) {
        shared_lock<shared_mutex> guard(rwMutex);
        coutMutex.lock();
        cout << "Reader " << readerID << " is about to read" << endl;
        coutMutex.unlock();
        randomDelay(60);
        coutMutex.lock();
        cout << "Reader " << readerID << " read " << myData << endl;
        coutMutex.unlock();
    }

    void writeMyData(int writerID) {
        lock_guard<shared_mutex> guard(rwMutex);
        cout << "Writer " << writerID << " is about to write" << endl;
        randomDelay(60);
        myData += 5;
        cout << "Writer " << writerID << " wrote " << myData << endl;
    }
};

RWDataBase rwDataBase;

void readerRun(int readerID) {
    for (int i = 0; i < 3; i++) {
        randomDelay(60);
        rwDataBase.readMyData(readerID);
    }
}

void writerRun(int writerID) {
    for (int i = 0; i < 3; i++) {
        randomDelay(60);
        rwDataBase.writeMyData(writerID);
    }
}

int main() {
    thread reader0(readerRun, 0);
    thread reader1(readerRun, 1);
    thread reader2(readerRun, 2);
    thread writer0(writerRun, 0);
    thread writer1(writerRun, 1);
    reader0.join();
    reader1.join();
    reader2.join();
    writer0.join();
    writer1.join();
    return EXIT_SUCCESS;
}
